/***
* Mousesup.prg
*
* Support functions for mouse support. Mouse.ch maps Clipper functions
* that mess with the mouse, or that write to the screen, to these
* routines.
*/


FUNCTION MScroll(nTop, nLeft, nBottom, nRight, nDirection)

LOCAL lSaveMouse := SetMouse(.F.)

  Scroll(nTop, nLeft, nBottom, nRight, nDirection)
  SetMouse(lSaveMouse)

RETURN NIL


FUNCTION MSetMode(nRows, nCols)

LOCAL lSaveMouse := SetMouse(.F.)
LOCAL lSaveResult

  lSaveResult := SetMode(nRows, nCols)
  MouseInit()
  SetMouse(lSaveMouse)

RETURN lSaveResult


FUNCTION MSaveScreen(nTop, nLeft, nBottom, nRight)

LOCAL lSaveResult
LOCAL lSaveMouse := SetMouse(.F.)

  lSaveResult := SaveScreen(nTop, nLeft, nBottom, nRight)
  SetMouse(lSaveMouse)

RETURN lSaveResult


FUNCTION MRestScreen(nTop, nLeft, nBottom, nRight, cSavedScreen)

LOCAL lSaveMouse := SetMouse(.F.)

  RestScreen(nTop, nLeft, nBottom, nRight, cSavedScreen)
  SetMouse(lSaveMouse)

RETURN NIL


// This is pretty ugly but I couldn't find a better way. Anyone
// with suggestions please email me or call.
FUNCTION MQout(aStrings)

LOCAL lSaveMouse := SetMouse(.F.)
LOCAL nStrings := Len(aStrings)

  DO CASE
    CASE nStrings == 1
      Qout(aStrings[1])

    CASE nStrings == 2
      Qout(aStrings[1], aStrings[2])

    CASE nStrings == 3
      Qout(aStrings[1], aStrings[2], aStrings[3])

    CASE nStrings == 4
      Qout(aStrings[1], aStrings[2], aStrings[3], aStrings[4])

    CASE nStrings == 5
      Qout(aStrings[1], aStrings[2], aStrings[3], aStrings[4], aStrings[5])
  ENDCASE
  SetMouse(lSaveMouse)

RETURN NIL


FUNCTION MQQout(aStrings)

LOCAL lSaveMouse := SetMouse(.F.)

  Aeval(aStrings, {|cString| QQOut(cString) })
  SetMouse(lSaveMouse)

RETURN NIL


FUNCTION MDevOut(cString, cColor)

LOCAL lSaveMouse := SetMouse(.F.)

  DevOut(cString, cColor)
  MouseOn(lSaveMouse)

RETURN NIL


FUNCTION MDevOutPict(xPr, cPic, cColor)

LOCAL lSaveMouse := SetMouse(.F.)

  DevOutPict(xPr, cPic, cColor)
  MouseOn(lSaveMouse)

RETURN NIL


FUNCTION MDispBox(p1, p2, p3, p4, p5, p6)

LOCAL lSaveMouse := SetMouse(.F.)

  DispBox(p1, p2, p3, p4, p5, p6)
  MouseOn(lSaveMouse)

RETURN NIL
